package org.openxma.addons.ui.table.caller.mdl;

import java.util.Locale;

import org.openxma.dsl.platform.enums.I18nEnum;
import org.openxma.dsl.platform.enums.I18nEnums;

public enum Gender implements I18nEnum {
    f("f"),
    m("m");

    private String key;

    private Gender(String key) {
        this.key = key;
    }

    public String getKey() {
        return this.key;
    }

    public String getLongValue(Locale locale) {
        return I18nEnums.longValueFromProvider(this, locale);
    }

    public String getShortValue(Locale locale) {
        return I18nEnums.shortValueFromProvider(this, locale);
    }

    public static Gender valueOfKey(String key) {
        return I18nEnums.valueOfKey(Gender.class,key);
    }
}
