package org.openxma.addons.ui.table.caller.mdl.dao;

import org.openxma.dsl.platform.dao.*;
import java.util.Collection;
import org.openxma.addons.ui.table.caller.mdl.dao.CallerDao;
import org.openxma.addons.ui.table.caller.mdl.model.CallerData;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity CallerDao.
 * @see CallerDao
 */
public interface CallerDaoGen extends GenericDao<CallerData,String>, EntityFactory<CallerData> {
	/**
	 * Query name constants
	 */
    static final String FIND_ALL_DATA = "CallerData.FindAllData";
    /**
	 * Stored procedure name constants
	 */
    /**
     * Factory method to create an empty <code>CallerData</code> entity with an already assigned identifier.
     * The advantage of this approach, coupled with the fact that we're using the id for equals,
     * is that equality test's are immediately possible and therefore independent from the persistence state
     * of the entity. This in contrast to other solutions where auto generated Keys are used
     * which must wait until the object is persisted or differentiate between transient and managed states.
     * @return a new (transient), empty <code>CallerData</code> entity with an already assigned identifier.
     */
    CallerData create();
    /**
     *
     * @return a collection containing 0 or more persistent CallerData instances
     */
    Collection<CallerData> findAllData();
}
