package org.openxma.addons.ui.table.caller.mdl.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import java.util.Collection;
import org.openxma.addons.ui.table.caller.mdl.dao.CallerDao;
import org.openxma.addons.ui.table.caller.mdl.model.CallerData;
import org.openxma.addons.ui.table.caller.mdl.model.impl.CallerDataImpl;
/**
 * @see CallerDao
 */
@SuppressWarnings("unused")
public abstract class CallerDaoGenImpl extends GenericDaoHibernateImpl<CallerData,String> implements CallerDao {

    public CallerDaoGenImpl() {
        super(CallerDataImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>CallerData</code> with an already assigned identifier.
     */
    public CallerData createEntity(Object context) {
        return create();
    }

    public CallerData create()
    {
        CallerData callerData = createEntityInstance();
        callerData.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return callerData;
    }
        
    public Collection<CallerData> findAllData() {
		String queryName = CallerDao.FIND_ALL_DATA;
        Query namedQuery = this.sessionFactory.getCurrentSession().getNamedQuery(queryName);
        applyFindAllDataQueryHints(namedQuery);
        return list(namedQuery);
    }

    protected void applyFindAllDataQueryHints(Query query) {
        // override this method and apply other hints that influence how a query is executed
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new CallerDaoQueryMapper();
	}
	
	protected class CallerDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
