package org.openxma.addons.ui.table.caller.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.caller.mdl.model.CallerData;
import org.openxma.dsl.platform.validation.Validators;

@SuppressWarnings("boxing")
public abstract class CallerDataGenValidator extends Validators {
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return CallerData.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(CallerData callerData) {
        Errors errors = createErrors(callerData);      
        validate(callerData,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        CallerData callerData = (CallerData) object;
        rejectIfMaxIntegerDigits(errors,"numCaller",callerData.getNumCaller(),3);
        rejectIfMaxFractionDigits(errors,"numCaller",callerData.getNumCaller(),2);
    }
    
}
