package org.openxma.addons.ui.table.customizer.caller.xma.client;


import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.swt.widgets.Shell;
import org.openxma.addons.ui.table.customizer.common.ColumnMetaData;
import org.openxma.addons.ui.table.customizer.common.CommonFilterModel;
import org.openxma.addons.ui.table.customizer.common.CommonDataModel.FilterOperator;
import org.openxma.addons.ui.table.customizer.xma.client.ITableCustomizer;

import at.spardat.enterprise.util.Types;
import at.spardat.xma.component.ComponentClient;
import at.spardat.xma.datasource.Domain;
import at.spardat.xma.datasource.DomainFmt;
import at.spardat.xma.mdl.AttachmentExceptionClient;
import at.spardat.xma.page.PageClient;

/**
 *
 */
public class CallerPage extends CallerPageGen {

    /**
     * Constructs the CallerPage.
     * @param parent the parent page
     */
    public CallerPage(PageClient parent) {
        super(parent);
    }

    /**
     * Constructs the CallerPage.
     * @param component the component this page belongs to
     */
    public CallerPage(ComponentClient component) {
        super(component);
    }

    /**
     * Constructs the CallerPage.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public CallerPage(ComponentClient component, Shell parentShell) {
        super(component,parentShell);
    }

    @Override
    public void createModels() {
        super.createModels();

        testtable.setColumnType(C4, Types.T_DOM);
        Domain domain = Domain.getInstance("type=rsc,bundle=org.openxma.addons.ui.table.caller.mdl.Gender", getSession());
        DomainFmt domainFmt = new DomainFmt(domain.getSpecTable(), getSession(), DomainFmt.SHORT_LONG);
        testtable.getColumn(C4).setFormatter(domainFmt);

    }


    @Override
    public void attachUIImpl() throws AttachmentExceptionClient {
        super.attachUIImpl();
    }


    @Override
    protected void createWidgets() {
        super.createWidgets();

        ITableCustomizer tablecustomizer = (ITableCustomizer) getTypedComponent().getSession().getComponent(ITableCustomizer.COMPONENT_NAME);
        tablecustomizer.setTableLayoutManager(testtableWLM);
        tablecustomizer.setTableWMClient(testtable);
        String fqtn = this.getClass().getName() + "testtable";
        tablecustomizer.setFQTableName(fqtn);
        Map<String, ColumnMetaData> columnMap = new HashMap<String, ColumnMetaData>();
//        tablecustomizer.setBackground(getComposite().getDisplay().getSystemColor(SWT.COLOR_WHITE));
        getComposite().setBackground(getComponent().getColor(255, 255, 255));


        columnMap.put("oid",new ColumnMetaData("oid","OID",-1,"Long"));
        columnMap.put("codCaller",new ColumnMetaData("codCaller","C1",0,"String"));
        columnMap.put("datCaller",new ColumnMetaData("datCaller","C2",1,"Date"));
        columnMap.put("numCaller",new ColumnMetaData("numCaller","C3",2,"Long"));
       // columnMap.put("gender",new ColumnMetaData("gender","C4",3));

        tablecustomizer.setAppCode("CALLER");
        tablecustomizer.setColumnMap(columnMap);
        tablecustomizer.setPagingWMClient(pagingInstance);
        tablecustomizer.init(); // must be called in order to register tablecustomizer at server
        customizerComponentId.set((short)tablecustomizer.getId());
        pagingInstance.setCustomizer(tablecustomizer);
    }

    /**
     * This method will be called every time the CallerPage becomes visible.
     */
    protected void enter() {
        super.enter();
        newRemoteCall("onInit").execute();
    }

    /**
     * Recalculates the state variables of this page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called imidiatly befor {@link #stateChanged()}.
     */
    public void determineState() {
        //TODO implement determineState here!
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called emediatly after {@link #determineState()}.
     */
    public void stateChanged() {
        //If XMA-DSL is used with expression, some enabling/disabling is done in super
        super.stateChanged();
        //TODO implement stateChanged here!
    }

    @Override
    protected void TestButtonWEvent() {
        ITableCustomizer customizer = (ITableCustomizer) pagingInstance.getCustomizer();
        customizer.setFilter(customizer.getFQTableName(), C1, true, Arrays.asList(new CommonFilterModel(FilterOperator.eq, "S0")));

//        getShell().getDisplay().asyncExec(new Runnable() {
//
//            public void run() {
//                for (int i = 0; i < 100; i++) {
//                    System.out.print(".");
//                    try {
//                        Thread.sleep(100);
//                    } catch (InterruptedException e) {
//                        // TODO Auto-generated catch block
//                        e.printStackTrace();
//                    }
//                }
//
//            }
//        });
//        newRemoteCall("startServer").execute();

    }

    @Override
    protected void pagingInstanceWReloadEvent() {
        newRemoteCall("onReloadTable").execute();
    }



}
