package org.openxma.addons.ui.table.customizer.caller.xma.server;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.session.XMASessionServer;

/**
 * This class implements the generic server part of CallerComponent.
 * It provides the mapping between typeIds and classnames
 * of all pages in the component.
 *
 */
abstract public class CallerComponentGen extends org.openxma.dsl.platform.xma.SpringComponentServer {


    /**
     * Initializes the CallerComponentGen. This method is called
     * by the XMA-Runtime.
     *
     * @param session the XMASession, this CallerComponentGen belongs to.
     * @param id the unique id of this CallerComponent.
     */
    public CallerComponentGen (XMASessionServer session,short id) {
        super (session,false,id);
    }


    /** the unique typeId for the page CallerPage */
    public static final short CallerPageClass = 0;

    /**
    * Array of the classnames of all pages in
    * this component. The typeIds are used as indices
    * into this array.
     */
    static final String[] modelClasses = {
        "CallerPage"
    };

    /**
    * Gets the short classname for the given typeId of
    * a page in this component. The short classname does
    * not contain the package.
    *
    * @param typeId the unique typeId
    * @return the short classname
     */
    static public String getShortModelClass(short typeId) {
        return modelClasses[typeId];
    }

    /**
    * Gets the full classname for the given typeId of
    * a page in this component.
    *
    * @param typeId the unique typeId
    * @return the full classname
     */
    public String getModelClass(short typeId) {
        return "org.openxma.addons.ui.table.customizer.caller.xma.server."+modelClasses[typeId];
    }


}
