package org.openxma.addons.ui.table.customizer.caller.xma.server;

import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Collection;

import org.openxma.addons.ui.table.caller.mdl.Gender;
import org.openxma.addons.ui.table.caller.mdl.dto.CallerDataView;
import org.openxma.addons.ui.table.caller.mdl.dto.CallerView;
import org.openxma.addons.ui.table.caller.mdl.service.CallerDAS;
import org.openxma.addons.ui.table.customizer.xma.server.ITableCustomizerServer;
import org.openxma.dsl.platform.query.QueryObject;
import org.springframework.beans.factory.annotation.Autowired;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.mdl.table.TableRow;
import at.spardat.xma.mdl.table.TableWM;
import at.spardat.xma.rpc.RemoteCall;
import at.spardat.xma.rpc.RemoteReply;
import at.spardat.xma.session.XMASessionServer;

/**
 *
 */
public class CallerPage extends CallerPageGen {

    @Autowired
    private CallerDAS callerDAS;


    /**
     * Constructs the CallerPage.
     *
     * @param component the component this page belongs to
     */
    public CallerPage(ComponentServer component) {
        super(component);
    }

    public void onInit(RemoteCall call, RemoteReply reply) {
        int n = 300;
        Calendar c = Calendar.getInstance();
        for (int i =0; i < 110;i++) {
            CallerDataView cd = new CallerDataView();
            cd.setCodCaller("S"+i);
            c.add(Calendar.DATE, 1);
            cd.setDatCaller(c.getTime());
            cd.setNumCaller(BigDecimal.valueOf(i));
          
            callerDAS.save(cd);
        }
        onReloadTable(call, reply);
    }

    public void onReloadTable(RemoteCall call, RemoteReply reply) {
        int offset = pagingInstance.getOffset();
        short pageSize = pagingInstance.getPageSize();
        short sortingColumn = pagingInstance.getSortingColumn();
        boolean isAscending = pagingInstance.getAscending();

        XMASessionServer xmaSessionServer = (XMASessionServer)XMASessionServer.getXMASession();
        ITableCustomizerServer tableCustomizerServer = (ITableCustomizerServer) xmaSessionServer.getComponent(Short.valueOf(customizerComponentId.getEncodedValue()));
        QueryObject filterQueryForTable = null;
        if (sortingColumn >-1) {
            filterQueryForTable =tableCustomizerServer.getQueryObject(sortingColumn,isAscending);
        } else {
            filterQueryForTable =tableCustomizerServer.getQueryObject();
        }
        filterQueryForTable.setFirstResult(offset);
        filterQueryForTable.setMaxResults(pageSize);
        Collection<CallerDataView> findAllData = callerDAS.findAllData(filterQueryForTable);
        testtableFill(findAllData);
    }

  

}