package org.openxma.addons.ui.table.customizer.caller.xma.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.paging.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.xma.mdl.table.*;
import java.util.*;

/**
 * This class implements the generic server part of CallerPage.
 * It implements the models of the page.
 *
 */
public abstract class CallerPageGen extends org.openxma.dsl.platform.xma.DslPageServer {
    ITableWM testtable;
    static final int C1 = 0;
    static final int C2 = 1;
    static final int C3 = 2;
    static final int C4 = 3;
    static final int C5 = 4;
    PagingWM pagingInstance;
    ISimpleWM customizerComponentId;
    WModel[] widgetModels;


    /**
     * Constructs the CallerPageGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public CallerPageGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        testtable = new TableWM((short) 0,this,5,TableWM.S_NULL|TableWM.S_ONE_WAY);
        testtable.setColumnType(C1,Types.T_STRING);
        testtable.setColumnType(C2,Types.T_DATE);
        testtable.setColumnType(C3,Types.T_BCD);
        customizerComponentId = new SimpleWM((short) 1, Types.T_BCD, this);
        pagingInstance = new PagingWM((short) 2,this,testtable);

        widgetModels = new WModel[] { (WModel) testtable, (WModel) pagingInstance, (WModel) customizerComponentId };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return CallerComponent.CallerPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public CallerComponent getTypedComponent() {
        return (CallerComponent) getComponent();
    }

    /**
     * This is a support method to create the table cells of one row from one or more BusinessDatas.
     * You may overwrite this method if you need a custom mapping from BusinessData attributes
     * to table columns that you were unable to specify in the UI designer.
     *
     * @return the returned Object[] is needed in the constructor of a <tt>TableRow</tt>.
     */
    public Object[] testtableCreateCells(org.openxma.addons.ui.table.caller.mdl.dto.CallerDataView CallerDataView) {
        Object []  cells = new Object[5];
        cells[0] = CallerDataView.getCodCaller();
        cells[1] = CallerDataView.getDatCaller();
        cells[2] = CallerDataView.getNumCaller();
        return cells;
    }

    /**
     * This method creates a TableRow object and adds it to the end of the table.
     * The key of the row is drawn from the key attribute specified in the UI designer.
     * The image id is resolved by calling testtableGetImageId. The cells of the table
     * are taken from a call to testtableCreateCells.
     */
    public TableRow testtableAddRow (org.openxma.addons.ui.table.caller.mdl.dto.CallerDataView CallerDataView) {
        return new TableRow ((TableWM)testtable, CallerDataView.getOid().toString(), testtableCreateCells (CallerDataView), testtableGetImageFor (CallerDataView));
    }

    /**
     * This method is called from <tt>testtableAddRow</tt> to figure out an image
     * id for a particular row. If you do not overwrite this method, the table row
     * does not have an image id. 
     */
    public int testtableGetImageFor (org.openxma.addons.ui.table.caller.mdl.dto.CallerDataView CallerDataView) {
        return 0;
    }

    /**
     * This method iterates over the collection and calls <tt>testtableAddRow</tt> for
     * each element.
     */
    public void testtableFill (Collection CallerDataView) {
        testtable.clear();
        for (Iterator iter = CallerDataView.iterator(); iter.hasNext();) {
            testtableAddRow ((org.openxma.addons.ui.table.caller.mdl.dto.CallerDataView) iter.next());
        }
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
