package org.openxma.addons.ui.table.customizer.common;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


public class CommonColumnModel extends CommonDataModel{


    private static final long serialVersionUID = 1L;

    private List<CommonFilterModel> filterModel = new ArrayList<CommonFilterModel>();
    private String txtColumn;
    private String namColumn;
    private Integer numOrder;
    private Integer sortOrder = Integer.MAX_VALUE;
    private Integer numColumnIndex;
    private Boolean visible = Boolean.TRUE;;
    private Boolean ascending = null;
    private Integer defWith;
    private Float defPercent;
    private Integer defMinWith;
    private Boolean resizeable = Boolean.FALSE;
    private Boolean andFilter = Boolean.TRUE;
    private Boolean nullableFilter = Boolean.FALSE;
    private CodDatatype codDataType;
    private String txtFormatterPattern;


    public void setTxtColumn(String txtColumn) {
        this.txtColumn = txtColumn;
    }

    public String getTxtColumn() {
        return txtColumn;
    }

    public void setNamColumn(String namColumn) {
        this.namColumn = namColumn;
    }

    public String getNamColumn() {
        return namColumn;
    }

    public void setNumOrder(Integer numOrder) {
        this.numOrder = numOrder;
    }

    public Integer getNumOrder() {
        return numOrder;
    }

    public void setSortOrder(Integer sortOrder) {
        this.sortOrder = sortOrder;
    }

    public Integer getSortOrder() {
        return sortOrder;
    }

    public void setNumColumnIndex(Integer numColumnIndex) {
        this.numColumnIndex = numColumnIndex;
    }

    public Integer getNumColumnIndex() {
        return numColumnIndex;
    }

    public void setVisible(Boolean visible) {
        this.visible = visible;
    }

    public Boolean isVisible() {
        return visible;
    }

    public void setAscending(Boolean ascending) {
        this.ascending = ascending;
    }

    public Boolean isAscending() {
        return Boolean.TRUE.equals(ascending);
    }
    public Boolean isDescending() {
        return Boolean.FALSE.equals(ascending);
    }

    public boolean isToBeSorted(){
        return ascending != null && sortOrder != Integer.MAX_VALUE;
    }

    public void setDefWith(Integer defWith) {
        this.defWith = defWith;
    }

    public Integer getDefWith() {
        return defWith;
    }

    public void setDefPercent(Float defPercent) {
        this.defPercent = defPercent;
    }

    public Float getDefPercent() {
        return defPercent;
    }

    public void setFilterModel(List<CommonFilterModel> filterModel) {
        if (filterModel == null) {
            removeFilterModel();
        } else {
            this.filterModel = filterModel;
        }
    }

    public void addFilterModel(CommonFilterModel filterModel) {
        getFilterModel().add(filterModel);
    }

    public void removeFilterModel(){
        this.filterModel = Collections.emptyList();
    }

    public List<CommonFilterModel> getFilterModel() {
        return filterModel;
    }

    public void setDefMinWith(Integer defMinWith) {
        this.defMinWith = defMinWith;
    }

    public Integer getDefMinWith() {
        return defMinWith;
    }

    public void setResizeable(Boolean resizeable) {
        this.resizeable = resizeable;
    }

    public Boolean isResizeable() {
        return resizeable;
    }

    public void setAndFilter(Boolean andFilter) {
        this.andFilter = andFilter;
    }

    public Boolean isAndFilter() {
        return andFilter;
    }

    public void setCodDataType(CodDatatype codDataType) {
        this.codDataType = codDataType;
    }

    public CodDatatype getCodDataType() {
        return codDataType;
    }

    public void setTxtFormatterPattern(String txtFormatterPattern) {
        this.txtFormatterPattern = txtFormatterPattern;
    }

    public String getTxtFormatterPattern() {
        return txtFormatterPattern;
    }

    public void setNullableFilter(Boolean nullableFilter) {
        this.nullableFilter = nullableFilter;
    }

    public Boolean isNullableFilter() {
        return nullableFilter==null?Boolean.FALSE:nullableFilter;
    }

}
