/*
 * @(#) $Id: $
 *
 * Copyright 2009/2010 by sIT Solutions, A-1110 Wien, Geiselbergstr.21-25. All rights reserved.
 */
package org.openxma.addons.ui.table.customizer.common;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;

import at.spardat.xma.page.PageClient;

public class DefaultTableCustomizerUISettings implements ITableCustomizerUISettings {

    private Color background;
    private Color foreground;
    private Font font;
    private String title;
    private Image cusimage;

    public DefaultTableCustomizerUISettings(Composite comp, PageClient pageClient) {
        Composite pageClientComposite = pageClient.getComposite();
        if (pageClientComposite!= null) {
            this.background = pageClientComposite.getBackground();
            this.foreground = pageClientComposite.getForeground();
            this.font = pageClientComposite.getFont();
        } else {
            this.background = comp.getBackground();
            this.foreground = comp.getForeground();
            this.font = comp.getFont();
        }
        this.title = "TableCustomizer";
        this.cusimage =  pageClient.getComponent().getImage(
                "org/openxma/addons/ui/table/customizer/xma/client/images/customizer_settings.png");
    }

    public Color getBackground() {
        return background;
    }

    public Image getCustomizerImage() {
        return cusimage;
    }

    public Font getFont() {
        return font;
    }

    public Color getForeground() {
        return foreground;
    }

    public String getTitle() {
        return title;
    }

}
