/*
 * @(#) $Id: $
 *
 * Copyright 2009/2010 by sIT Solutions, A-1110 Wien, Geiselbergstr.21-25. All rights reserved.
 */
package org.openxma.addons.ui.table.customizer.common;

import org.eclipse.swt.widgets.Composite;

import at.spardat.xma.page.PageClient;

public class TableCustomizerUISettingsFactory {

    public static final String RUNTIME_PROPERTY = "addons.ui.table.customizer.UISettingsImpl";

    /**
     * returns default settings for the tablecustomizer font backgroundcolor<br>
     * and forgroundcolor are defined by thecomposite of the pageClient
     *
     * @param pageClient
     * @return
     *
     */
    public static ITableCustomizerUISettings createUISettings(final PageClient pageClient, final Composite comp) {

        String runtimeProperty =  pageClient.getComponent().getSession().getRuntimeProperty(RUNTIME_PROPERTY);
        if (runtimeProperty == null) {
            return new DefaultTableCustomizerUISettings(comp, pageClient);
        } else {
            try {
                Class<?> customTableCustomizerUISettings = Class.forName(runtimeProperty);
                try {
                    ITableCustomizerUISettings newInstance = (ITableCustomizerUISettings) customTableCustomizerUISettings
                            .newInstance();
                    return newInstance;
                } catch (InstantiationException e) {
                    throw new IllegalArgumentException(e);
                } catch (IllegalAccessException e) {
                    throw new IllegalArgumentException(e);

                }
            } catch (ClassNotFoundException e) {
                throw new IllegalArgumentException(e);
            }
        }

    }

}
