package org.openxma.addons.ui.table.customizer.mdl.dao;

import org.openxma.dsl.platform.dao.*;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerColumnDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity TableCustomizerColumnDao.
 * @see TableCustomizerColumnDao
 */
public interface TableCustomizerColumnDaoGen extends GenericDao<TableCustomizerColumn,String>, EntityFactory<TableCustomizerColumn> {
    /**
     * Factory method to create an empty <code>TableCustomizerColumn</code> entity with an already assigned identifier.
     * The advantage of this approach, coupled with the fact that we're using the id for equals,
     * is that equality test's are immediately possible and therefore independent from the persistence state
     * of the entity. This in contrast to other solutions where auto generated Keys are used
     * which must wait until the object is persisted or differentiate between transient and managed states.
     * @return a new (transient), empty <code>TableCustomizerColumn</code> entity with an already assigned identifier.
     */
    TableCustomizerColumn create();
    /**
     * Factory method to create an empty <code>TableCustomizerColumn</code> taking all not null attributes.
     *
	 * @param tableCustomizerTable
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param namColumn
     * @return a new (transient ) <code>TableCustomizerColumn</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerColumn create(TableCustomizerTable tableCustomizerTable,String codOwner,Integer numMandant,String fipUser,String namColumn);
    /**
     * Factory method to create and save an empty <code>TableCustomizerColumn</code> taking all not null attributes.
     *
	 * @param tableCustomizerTable
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param namColumn
     * @return a new (transient) <code>TableCustomizerColumn</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerColumn createAndSave(TableCustomizerTable tableCustomizerTable,String codOwner,Integer numMandant,String fipUser,String namColumn);
}
