package org.openxma.addons.ui.table.customizer.mdl.dao;

import org.openxma.dsl.platform.dao.*;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerFilterDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerFilter;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity TableCustomizerFilterDao.
 * @see TableCustomizerFilterDao
 */
public interface TableCustomizerFilterDaoGen extends GenericDao<TableCustomizerFilter,String>, EntityFactory<TableCustomizerFilter> {
    /**
     * Factory method to create an empty <code>TableCustomizerFilter</code> entity with an already assigned identifier.
     * The advantage of this approach, coupled with the fact that we're using the id for equals,
     * is that equality test's are immediately possible and therefore independent from the persistence state
     * of the entity. This in contrast to other solutions where auto generated Keys are used
     * which must wait until the object is persisted or differentiate between transient and managed states.
     * @return a new (transient), empty <code>TableCustomizerFilter</code> entity with an already assigned identifier.
     */
    TableCustomizerFilter create();
    /**
     * Factory method to create an empty <code>TableCustomizerFilter</code> taking all not null attributes.
     *
	 * @param tableCustomizerColumn
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
     * @return a new (transient ) <code>TableCustomizerFilter</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerFilter create(TableCustomizerColumn tableCustomizerColumn,String codOwner,Integer numMandant,String fipUser);
    /**
     * Factory method to create and save an empty <code>TableCustomizerFilter</code> taking all not null attributes.
     *
	 * @param tableCustomizerColumn
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
     * @return a new (transient) <code>TableCustomizerFilter</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerFilter createAndSave(TableCustomizerColumn tableCustomizerColumn,String codOwner,Integer numMandant,String fipUser);
}
