package org.openxma.addons.ui.table.customizer.mdl.dao;

import org.openxma.dsl.platform.dao.*;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerTableDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity TableCustomizerTableDao.
 * @see TableCustomizerTableDao
 */
public interface TableCustomizerTableDaoGen extends GenericDao<TableCustomizerTable,String>, EntityFactory<TableCustomizerTable> {
	/**
	 * Query name constants
	 */
    static final String FIND_TABLE_FOR_USER = "TableCustomizerTable.FindTableForUser";
    /**
	 * Stored procedure name constants
	 */
    /**
     * Factory method to create an empty <code>TableCustomizerTable</code> entity with an already assigned identifier.
     * The advantage of this approach, coupled with the fact that we're using the id for equals,
     * is that equality test's are immediately possible and therefore independent from the persistence state
     * of the entity. This in contrast to other solutions where auto generated Keys are used
     * which must wait until the object is persisted or differentiate between transient and managed states.
     * @return a new (transient), empty <code>TableCustomizerTable</code> entity with an already assigned identifier.
     */
    TableCustomizerTable create();
    /**
     * Factory method to create an empty <code>TableCustomizerTable</code> taking all not null attributes.
     *
	 * @param tableCustomizerUser
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param namTable
     * @return a new (transient ) <code>TableCustomizerTable</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerTable create(TableCustomizerUser tableCustomizerUser,String codOwner,Integer numMandant,String fipUser,String namTable);
    /**
     * Factory method to create and save an empty <code>TableCustomizerTable</code> taking all not null attributes.
     *
	 * @param tableCustomizerUser
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param namTable
     * @return a new (transient) <code>TableCustomizerTable</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerTable createAndSave(TableCustomizerUser tableCustomizerUser,String codOwner,Integer numMandant,String fipUser,String namTable);
    /**
     *
     * @param codUser
     * @param numMandant
     * @param tableName
     * @return the tableCustomizerTable instance, or <code>null</code> if not found
     */
    TableCustomizerTable findTableForUser(String codUser,Integer numMandant,String tableName);
}
