package org.openxma.addons.ui.table.customizer.mdl.dao;

import org.openxma.dsl.platform.dao.*;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerUserDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;

/**
 * Represents a Data Access Object, as defined in the
 * Core J2EE Pattern Catalog (see http://java.sun.com/blueprints/corej2eepatterns/Patterns/DataAccessObject.html),
 * to abstract and encapsulate all access to entity TableCustomizerUserDao.
 * @see TableCustomizerUserDao
 */
public interface TableCustomizerUserDaoGen extends GenericDao<TableCustomizerUser,String>, EntityFactory<TableCustomizerUser> {
	/**
	 * Query name constants
	 */
    static final String FIND_USER = "TableCustomizerUser.FindUser";
    /**
	 * Stored procedure name constants
	 */
    /**
     * Factory method to create an empty <code>TableCustomizerUser</code> entity with an already assigned identifier.
     * The advantage of this approach, coupled with the fact that we're using the id for equals,
     * is that equality test's are immediately possible and therefore independent from the persistence state
     * of the entity. This in contrast to other solutions where auto generated Keys are used
     * which must wait until the object is persisted or differentiate between transient and managed states.
     * @return a new (transient), empty <code>TableCustomizerUser</code> entity with an already assigned identifier.
     */
    TableCustomizerUser create();
    /**
     * Factory method to create an empty <code>TableCustomizerUser</code> taking all not null attributes.
     *
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param codUser
     * @return a new (transient ) <code>TableCustomizerUser</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerUser create(String codOwner,Integer numMandant,String fipUser,String codUser);
    /**
     * Factory method to create and save an empty <code>TableCustomizerUser</code> taking all not null attributes.
     *
	 * @param codOwner
	 * @param numMandant
	 * @param fipUser
	 * @param codUser
     * @return a new (transient) <code>TableCustomizerUser</code> entity with the given natural identifier and not null attributes set.
     */
    TableCustomizerUser createAndSave(String codOwner,Integer numMandant,String fipUser,String codUser);
    /**
     *
     * @param codUser
     * @param numMandant
     * @return the tableCustomizerUser instance, or <code>null</code> if not found
     */
    TableCustomizerUser findUser(String codUser,Integer numMandant);
}
