package org.openxma.addons.ui.table.customizer.mdl.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerColumnDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerColumnImpl;
/**
 * @see TableCustomizerColumnDao
 */
@SuppressWarnings("unused")
public abstract class TableCustomizerColumnDaoGenImpl extends GenericDaoHibernateImpl<TableCustomizerColumn,String> implements TableCustomizerColumnDao {

    public TableCustomizerColumnDaoGenImpl() {
        super(TableCustomizerColumnImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>TableCustomizerColumn</code> with an already assigned identifier.
     */
    public TableCustomizerColumn createEntity(Object context) {
        return create();
    }

    public TableCustomizerColumn create()
    {
        TableCustomizerColumn tableCustomizerColumn = createEntityInstance();
        tableCustomizerColumn.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return tableCustomizerColumn;
    }

    public TableCustomizerColumn create(TableCustomizerTable tableCustomizerTable,String codOwner,Integer numMandant,String fipUser,String namColumn) {
        Assert.notNull(tableCustomizerTable, "Parameter 'tableCustomizerTable' must not be null");
        Assert.notNull(codOwner, "Parameter 'codOwner' must not be null");
        Assert.notNull(numMandant, "Parameter 'numMandant' must not be null");
        Assert.notNull(fipUser, "Parameter 'fipUser' must not be null");
        Assert.notNull(namColumn, "Parameter 'namColumn' must not be null");
        TableCustomizerColumn tableCustomizerColumn = (TableCustomizerColumn) create();
        tableCustomizerColumn.setTableCustomizerTable(tableCustomizerTable);
        tableCustomizerColumn.setCodOwner(codOwner);
        tableCustomizerColumn.setNumMandant(numMandant);
        tableCustomizerColumn.setFipUser(fipUser);
        tableCustomizerColumn.setNamColumn(namColumn);
        return tableCustomizerColumn;
    }

    public TableCustomizerColumn createAndSave(TableCustomizerTable tableCustomizerTable,String codOwner,Integer numMandant,String fipUser,String namColumn) {
        TableCustomizerColumn tableCustomizerColumn = create(tableCustomizerTable,codOwner,numMandant,fipUser,namColumn);
        saveOrUpdate(tableCustomizerColumn);
        return tableCustomizerColumn;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new TableCustomizerColumnDaoQueryMapper();
	}
	
	protected class TableCustomizerColumnDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
