package org.openxma.addons.ui.table.customizer.mdl.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerFilterDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerFilter;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerFilterImpl;
/**
 * @see TableCustomizerFilterDao
 */
@SuppressWarnings("unused")
public abstract class TableCustomizerFilterDaoGenImpl extends GenericDaoHibernateImpl<TableCustomizerFilter,String> implements TableCustomizerFilterDao {

    public TableCustomizerFilterDaoGenImpl() {
        super(TableCustomizerFilterImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>TableCustomizerFilter</code> with an already assigned identifier.
     */
    public TableCustomizerFilter createEntity(Object context) {
        return create();
    }

    public TableCustomizerFilter create()
    {
        TableCustomizerFilter tableCustomizerFilter = createEntityInstance();
        tableCustomizerFilter.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return tableCustomizerFilter;
    }

    public TableCustomizerFilter create(TableCustomizerColumn tableCustomizerColumn,String codOwner,Integer numMandant,String fipUser) {
        Assert.notNull(tableCustomizerColumn, "Parameter 'tableCustomizerColumn' must not be null");
        Assert.notNull(codOwner, "Parameter 'codOwner' must not be null");
        Assert.notNull(numMandant, "Parameter 'numMandant' must not be null");
        Assert.notNull(fipUser, "Parameter 'fipUser' must not be null");
        TableCustomizerFilter tableCustomizerFilter = (TableCustomizerFilter) create();
        tableCustomizerFilter.setTableCustomizerColumn(tableCustomizerColumn);
        tableCustomizerFilter.setCodOwner(codOwner);
        tableCustomizerFilter.setNumMandant(numMandant);
        tableCustomizerFilter.setFipUser(fipUser);
        return tableCustomizerFilter;
    }

    public TableCustomizerFilter createAndSave(TableCustomizerColumn tableCustomizerColumn,String codOwner,Integer numMandant,String fipUser) {
        TableCustomizerFilter tableCustomizerFilter = create(tableCustomizerColumn,codOwner,numMandant,fipUser);
        saveOrUpdate(tableCustomizerFilter);
        return tableCustomizerFilter;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new TableCustomizerFilterDaoQueryMapper();
	}
	
	protected class TableCustomizerFilterDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
