package org.openxma.addons.ui.table.customizer.mdl.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerTableDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerTableImpl;
/**
 * @see TableCustomizerTableDao
 */
@SuppressWarnings("unused")
public abstract class TableCustomizerTableDaoGenImpl extends GenericDaoHibernateImpl<TableCustomizerTable,String> implements TableCustomizerTableDao {

    public TableCustomizerTableDaoGenImpl() {
        super(TableCustomizerTableImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>TableCustomizerTable</code> with an already assigned identifier.
     */
    public TableCustomizerTable createEntity(Object context) {
        return create();
    }

    public TableCustomizerTable create()
    {
        TableCustomizerTable tableCustomizerTable = createEntityInstance();
        tableCustomizerTable.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return tableCustomizerTable;
    }

    public TableCustomizerTable create(TableCustomizerUser tableCustomizerUser,String codOwner,Integer numMandant,String fipUser,String namTable) {
        Assert.notNull(tableCustomizerUser, "Parameter 'tableCustomizerUser' must not be null");
        Assert.notNull(codOwner, "Parameter 'codOwner' must not be null");
        Assert.notNull(numMandant, "Parameter 'numMandant' must not be null");
        Assert.notNull(fipUser, "Parameter 'fipUser' must not be null");
        Assert.notNull(namTable, "Parameter 'namTable' must not be null");
        TableCustomizerTable tableCustomizerTable = (TableCustomizerTable) create();
        tableCustomizerTable.setTableCustomizerUser(tableCustomizerUser);
        tableCustomizerTable.setCodOwner(codOwner);
        tableCustomizerTable.setNumMandant(numMandant);
        tableCustomizerTable.setFipUser(fipUser);
        tableCustomizerTable.setNamTable(namTable);
        return tableCustomizerTable;
    }

    public TableCustomizerTable createAndSave(TableCustomizerUser tableCustomizerUser,String codOwner,Integer numMandant,String fipUser,String namTable) {
        TableCustomizerTable tableCustomizerTable = create(tableCustomizerUser,codOwner,numMandant,fipUser,namTable);
        saveOrUpdate(tableCustomizerTable);
        return tableCustomizerTable;
    }
        
    public TableCustomizerTable findTableForUser(String codUser,Integer numMandant,String tableName) {
		String queryName = TableCustomizerTableDao.FIND_TABLE_FOR_USER;
        Query namedQuery = this.sessionFactory.getCurrentSession().getNamedQuery(queryName);
        namedQuery.setParameter("codUser", codUser);
        namedQuery.setParameter("numMandant", numMandant);
        namedQuery.setParameter("tableName", tableName);
        applyFindTableForUserQueryHints(namedQuery,codUser,numMandant,tableName);
        return unique(namedQuery);
    }

    protected void applyFindTableForUserQueryHints(Query query,String codUser,Integer numMandant,String tableName) {
        // override this method and apply other hints that influence how a query is executed
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new TableCustomizerTableDaoQueryMapper();
	}
	
	protected class TableCustomizerTableDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
