package org.openxma.addons.ui.table.customizer.mdl.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerUserDao;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerUserImpl;
/**
 * @see TableCustomizerUserDao
 */
@SuppressWarnings("unused")
public abstract class TableCustomizerUserDaoGenImpl extends GenericDaoHibernateImpl<TableCustomizerUser,String> implements TableCustomizerUserDao {

    public TableCustomizerUserDaoGenImpl() {
        super(TableCustomizerUserImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>TableCustomizerUser</code> with an already assigned identifier.
     */
    public TableCustomizerUser createEntity(Object context) {
        return create();
    }

    public TableCustomizerUser create()
    {
        TableCustomizerUser tableCustomizerUser = createEntityInstance();
        tableCustomizerUser.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return tableCustomizerUser;
    }

    public TableCustomizerUser create(String codOwner,Integer numMandant,String fipUser,String codUser) {
        Assert.notNull(codOwner, "Parameter 'codOwner' must not be null");
        Assert.notNull(numMandant, "Parameter 'numMandant' must not be null");
        Assert.notNull(fipUser, "Parameter 'fipUser' must not be null");
        Assert.notNull(codUser, "Parameter 'codUser' must not be null");
        TableCustomizerUser tableCustomizerUser = (TableCustomizerUser) create();
        tableCustomizerUser.setCodOwner(codOwner);
        tableCustomizerUser.setNumMandant(numMandant);
        tableCustomizerUser.setFipUser(fipUser);
        tableCustomizerUser.setCodUser(codUser);
        return tableCustomizerUser;
    }

    public TableCustomizerUser createAndSave(String codOwner,Integer numMandant,String fipUser,String codUser) {
        TableCustomizerUser tableCustomizerUser = create(codOwner,numMandant,fipUser,codUser);
        saveOrUpdate(tableCustomizerUser);
        return tableCustomizerUser;
    }
        
    public TableCustomizerUser findUser(String codUser,Integer numMandant) {
		String queryName = TableCustomizerUserDao.FIND_USER;
        Query namedQuery = this.sessionFactory.getCurrentSession().getNamedQuery(queryName);
        namedQuery.setParameter("codUser", codUser);
        namedQuery.setParameter("numMandant", numMandant);
        applyFindUserQueryHints(namedQuery,codUser,numMandant);
        return unique(namedQuery);
    }

    protected void applyFindUserQueryHints(Query query,String codUser,Integer numMandant) {
        // override this method and apply other hints that influence how a query is executed
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new TableCustomizerUserDaoQueryMapper();
	}
	
	protected class TableCustomizerUserDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
