package org.openxma.addons.ui.table.customizer.mdl.model.impl;

import java.math.BigDecimal;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerFilter;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerEntityImpl;

public abstract class TableCustomizerColumnGenImpl extends TableCustomizerEntityImpl implements TableCustomizerColumn {
	protected String namColumn;
	protected String txtColumn;
	protected Integer numSort;
	protected Boolean bolAscending;
	protected Integer numOrder;
	protected Boolean bolVisible;
	protected Integer numDefaultWidth;
	protected Integer numColumnIndex;
	protected BigDecimal ratDefault;
	protected Boolean bolIsStretchColumn;
	protected Integer numDefaultMinWith;
	protected Boolean bolIsResizable;
	protected String codDataType;
	protected Boolean bolAndFilter;
	protected Boolean bolIsNullableFilter;
	protected String txtFormatterPattern;
	protected Set<TableCustomizerFilter> tableCustomizerFilter;
	protected TableCustomizerTable tableCustomizerTable;
    
	public String getNamColumn() {
		return this.namColumn;
	}
	
	public void setNamColumn(String namColumn) {
		this.namColumn = namColumn;
	}

	public String getTxtColumn() {
		return this.txtColumn;
	}
	
	public void setTxtColumn(String txtColumn) {
		this.txtColumn = txtColumn;
	}

	public Integer getNumSort() {
		return this.numSort;
	}
	
	public void setNumSort(Integer numSort) {
		this.numSort = numSort;
	}

	public Boolean getBolAscending() {
		return this.bolAscending;
	}
	
	public void setBolAscending(Boolean bolAscending) {
		this.bolAscending = bolAscending;
	}

	public Integer getNumOrder() {
		return this.numOrder;
	}
	
	public void setNumOrder(Integer numOrder) {
		this.numOrder = numOrder;
	}

	public Boolean getBolVisible() {
		return this.bolVisible;
	}
	
	public void setBolVisible(Boolean bolVisible) {
		this.bolVisible = bolVisible;
	}

	public Integer getNumDefaultWidth() {
		return this.numDefaultWidth;
	}
	
	public void setNumDefaultWidth(Integer numDefaultWidth) {
		this.numDefaultWidth = numDefaultWidth;
	}

	public Integer getNumColumnIndex() {
		return this.numColumnIndex;
	}
	
	public void setNumColumnIndex(Integer numColumnIndex) {
		this.numColumnIndex = numColumnIndex;
	}

	public BigDecimal getRatDefault() {
		return this.ratDefault;
	}
	
	public void setRatDefault(BigDecimal ratDefault) {
		this.ratDefault = ratDefault;
	}

	public Boolean getBolIsStretchColumn() {
		return this.bolIsStretchColumn;
	}
	
	public void setBolIsStretchColumn(Boolean bolIsStretchColumn) {
		this.bolIsStretchColumn = bolIsStretchColumn;
	}

	public Integer getNumDefaultMinWith() {
		return this.numDefaultMinWith;
	}
	
	public void setNumDefaultMinWith(Integer numDefaultMinWith) {
		this.numDefaultMinWith = numDefaultMinWith;
	}

	public Boolean getBolIsResizable() {
		return this.bolIsResizable;
	}
	
	public void setBolIsResizable(Boolean bolIsResizable) {
		this.bolIsResizable = bolIsResizable;
	}

	public String getCodDataType() {
		return this.codDataType;
	}
	
	public void setCodDataType(String codDataType) {
		this.codDataType = codDataType;
	}

	public Boolean getBolAndFilter() {
		return this.bolAndFilter;
	}
	
	public void setBolAndFilter(Boolean bolAndFilter) {
		this.bolAndFilter = bolAndFilter;
	}

	public Boolean getBolIsNullableFilter() {
		return this.bolIsNullableFilter;
	}
	
	public void setBolIsNullableFilter(Boolean bolIsNullableFilter) {
		this.bolIsNullableFilter = bolIsNullableFilter;
	}

	public String getTxtFormatterPattern() {
		return this.txtFormatterPattern;
	}
	
	public void setTxtFormatterPattern(String txtFormatterPattern) {
		this.txtFormatterPattern = txtFormatterPattern;
	}

	public Set<TableCustomizerFilter> getTableCustomizerFilter() {
		if (this.tableCustomizerFilter == null) {
            this.tableCustomizerFilter = new HashSet<TableCustomizerFilter>();
        }
        return Collections.unmodifiableSet(this.tableCustomizerFilter);
	}
	
	public boolean hasTableCustomizerFilter() {
		return tableCustomizerFilter != null && !tableCustomizerFilter.isEmpty();
	}

	public void addTableCustomizerFilter(TableCustomizerFilter tableCustomizerFilter) {
		if (tableCustomizerFilter == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerFilter' must not be null");
		}
		if (!getTableCustomizerFilter().contains(tableCustomizerFilter)) {
			this.tableCustomizerFilter.add(tableCustomizerFilter);
			tableCustomizerFilter.setTableCustomizerColumn(this);
		}
	}

	public void removeTableCustomizerFilter(TableCustomizerFilter tableCustomizerFilter) {
		if (tableCustomizerFilter == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerFilter' must not be null");
		}
		if (getTableCustomizerFilter().contains(tableCustomizerFilter)) {
            this.tableCustomizerFilter.remove(tableCustomizerFilter);
			tableCustomizerFilter.setTableCustomizerColumn(null);
		}
	}

    public void removeAllTableCustomizerFilter() {
        if (this.tableCustomizerFilter != null) {
            this.tableCustomizerFilter.clear();
        }
    }

	public TableCustomizerTable getTableCustomizerTable() {
		return this.tableCustomizerTable;
	}
	
	public void setTableCustomizerTable(TableCustomizerTable tableCustomizerTable) {
		if (this.tableCustomizerTable != tableCustomizerTable) {
			if (this.tableCustomizerTable != null) {
				this.tableCustomizerTable.removeTableCustomizerColumns(this);
			}
			this.tableCustomizerTable = tableCustomizerTable;
			if (tableCustomizerTable != null) {
				tableCustomizerTable.addTableCustomizerColumns(this);
			}
		}
	}
	
    @Override
    public String toString() {
    	StringBuilder toStringBuilder = new StringBuilder("TableCustomizerColumn [");
    	toStringBuilder.append(super.toString()).append(",");
        toStringBuilder.append("namColumn=").append(getNamColumn()).append(",");
        toStringBuilder.append("txtColumn=").append(getTxtColumn()).append(",");
        toStringBuilder.append("numSort=").append(getNumSort()).append(",");
        toStringBuilder.append("bolAscending=").append(getBolAscending()).append(",");
        toStringBuilder.append("numOrder=").append(getNumOrder()).append(",");
        toStringBuilder.append("bolVisible=").append(getBolVisible()).append(",");
        toStringBuilder.append("numDefaultWidth=").append(getNumDefaultWidth()).append(",");
        toStringBuilder.append("numColumnIndex=").append(getNumColumnIndex()).append(",");
        toStringBuilder.append("ratDefault=").append(getRatDefault()).append(",");
        toStringBuilder.append("bolIsStretchColumn=").append(getBolIsStretchColumn()).append(",");
        toStringBuilder.append("numDefaultMinWith=").append(getNumDefaultMinWith()).append(",");
        toStringBuilder.append("bolIsResizable=").append(getBolIsResizable()).append(",");
        toStringBuilder.append("codDataType=").append(getCodDataType()).append(",");
        toStringBuilder.append("bolAndFilter=").append(getBolAndFilter()).append(",");
        toStringBuilder.append("bolIsNullableFilter=").append(getBolIsNullableFilter()).append(",");
        toStringBuilder.append("txtFormatterPattern=").append(getTxtFormatterPattern());
        return toStringBuilder.append("]").toString();
    }
}
