package org.openxma.addons.ui.table.customizer.mdl.model.impl;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerEntityImpl;

public abstract class TableCustomizerTableGenImpl extends TableCustomizerEntityImpl implements TableCustomizerTable {
	protected String namTable;
	protected Set<TableCustomizerColumn> tableCustomizerColumns;
	protected TableCustomizerUser tableCustomizerUser;
    
	public String getNamTable() {
		return this.namTable;
	}
	
	public void setNamTable(String namTable) {
		this.namTable = namTable;
	}

	public Set<TableCustomizerColumn> getTableCustomizerColumns() {
		if (this.tableCustomizerColumns == null) {
            this.tableCustomizerColumns = new HashSet<TableCustomizerColumn>();
        }
        return Collections.unmodifiableSet(this.tableCustomizerColumns);
	}
	
	public boolean hasTableCustomizerColumns() {
		return tableCustomizerColumns != null && !tableCustomizerColumns.isEmpty();
	}

	public void addTableCustomizerColumns(TableCustomizerColumn tableCustomizerColumns) {
		if (tableCustomizerColumns == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerColumns' must not be null");
		}
		if (!getTableCustomizerColumns().contains(tableCustomizerColumns)) {
			this.tableCustomizerColumns.add(tableCustomizerColumns);
			tableCustomizerColumns.setTableCustomizerTable(this);
		}
	}

	public void removeTableCustomizerColumns(TableCustomizerColumn tableCustomizerColumns) {
		if (tableCustomizerColumns == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerColumns' must not be null");
		}
		if (getTableCustomizerColumns().contains(tableCustomizerColumns)) {
            this.tableCustomizerColumns.remove(tableCustomizerColumns);
			tableCustomizerColumns.setTableCustomizerTable(null);
		}
	}

    public void removeAllTableCustomizerColumns() {
        if (this.tableCustomizerColumns != null) {
            this.tableCustomizerColumns.clear();
        }
    }

	public TableCustomizerUser getTableCustomizerUser() {
		return this.tableCustomizerUser;
	}
	
	public void setTableCustomizerUser(TableCustomizerUser tableCustomizerUser) {
		if (this.tableCustomizerUser != tableCustomizerUser) {
			if (this.tableCustomizerUser != null) {
				this.tableCustomizerUser.removeTableCustomizerTables(this);
			}
			this.tableCustomizerUser = tableCustomizerUser;
			if (tableCustomizerUser != null) {
				tableCustomizerUser.addTableCustomizerTables(this);
			}
		}
	}
	
    @Override
    public String toString() {
    	StringBuilder toStringBuilder = new StringBuilder("TableCustomizerTable [");
    	toStringBuilder.append(super.toString()).append(",");
        toStringBuilder.append("namTable=").append(getNamTable());
        return toStringBuilder.append("]").toString();
    }
}
