package org.openxma.addons.ui.table.customizer.mdl.model.impl;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.model.impl.TableCustomizerEntityImpl;

public abstract class TableCustomizerUserGenImpl extends TableCustomizerEntityImpl implements TableCustomizerUser {
	protected String codUser;
	protected Set<TableCustomizerTable> tableCustomizerTables;
    
	public String getCodUser() {
		return this.codUser;
	}
	
	public void setCodUser(String codUser) {
		this.codUser = codUser;
	}

	public Set<TableCustomizerTable> getTableCustomizerTables() {
		if (this.tableCustomizerTables == null) {
            this.tableCustomizerTables = new HashSet<TableCustomizerTable>();
        }
        return Collections.unmodifiableSet(this.tableCustomizerTables);
	}
	
	public boolean hasTableCustomizerTables() {
		return tableCustomizerTables != null && !tableCustomizerTables.isEmpty();
	}

	public void addTableCustomizerTables(TableCustomizerTable tableCustomizerTables) {
		if (tableCustomizerTables == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerTables' must not be null");
		}
		if (!getTableCustomizerTables().contains(tableCustomizerTables)) {
			this.tableCustomizerTables.add(tableCustomizerTables);
			tableCustomizerTables.setTableCustomizerUser(this);
		}
	}

	public void removeTableCustomizerTables(TableCustomizerTable tableCustomizerTables) {
		if (tableCustomizerTables == null) {
			throw new IllegalArgumentException("parameter 'tableCustomizerTables' must not be null");
		}
		if (getTableCustomizerTables().contains(tableCustomizerTables)) {
            this.tableCustomizerTables.remove(tableCustomizerTables);
			tableCustomizerTables.setTableCustomizerUser(null);
		}
	}

    public void removeAllTableCustomizerTables() {
        if (this.tableCustomizerTables != null) {
            this.tableCustomizerTables.clear();
        }
    }
	
    @Override
    public String toString() {
    	StringBuilder toStringBuilder = new StringBuilder("TableCustomizerUser [");
    	toStringBuilder.append(super.toString()).append(",");
        toStringBuilder.append("codUser=").append(getCodUser());
        return toStringBuilder.append("]").toString();
    }
}
