package org.openxma.addons.ui.table.customizer.mdl.service.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.openxma.dsl.platform.service.Mapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerTableDao;
import org.openxma.addons.ui.table.customizer.mdl.dao.TableCustomizerUserDao;
import org.openxma.addons.ui.table.customizer.mdl.dto.TableCustomizerTableView;
import org.openxma.addons.ui.table.customizer.mdl.dto.TableCustomizerUserView;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.service.TableCustomizerDas;
import org.springframework.dao.OptimisticLockingFailureException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.Assert;
public abstract class TableCustomizerDasGenImpl implements TableCustomizerDas {
    protected final Log logger = LogFactory.getLog(getClass());
    @Autowired(required=false)
    protected Mapper mapper;
    protected TableCustomizerUserDao tableCustomizerUserDao;
    protected TableCustomizerTableDao tableCustomizerTableDao;
    
    @Autowired
    public void setTableCustomizerUserDao(TableCustomizerUserDao tableCustomizerUserDao) {
        this.tableCustomizerUserDao = tableCustomizerUserDao;
    }

    @Autowired
    public void setTableCustomizerTableDao(TableCustomizerTableDao tableCustomizerTableDao) {
        this.tableCustomizerTableDao = tableCustomizerTableDao;
    }
    
    @Transactional
	public TableCustomizerUserView save(TableCustomizerUserView tableCustomizerUserView) {
        Assert.notNull(tableCustomizerUserView, "parameter 'tableCustomizerUserView' must not be null");
        TableCustomizerUser tableCustomizerUser = this.mapper.createAndMapOne(tableCustomizerUserView, TableCustomizerUser.class,"saveTableCustomizerUser");
        this.tableCustomizerUserDao.saveOrUpdate(tableCustomizerUser);
        return this.mapper.mapOne(tableCustomizerUser,new TableCustomizerUserView());
    }
    
    @Transactional(readOnly = true)
	public TableCustomizerUserView loadTableCustomizerUserView(String oid) {
        Assert.notNull(oid, "parameter 'oid' must not be null");
        return this.mapper.createAndMapOne(this.tableCustomizerUserDao.load(oid),TableCustomizerUserView.class);
    }
    
    @Transactional
	public void update(TableCustomizerUserView tableCustomizerUserView) {
        Assert.notNull(tableCustomizerUserView, "parameter 'tableCustomizerUserView' must not be null");
        TableCustomizerUser mappedTableCustomizerUser = this.mapper.createAndMapOne(tableCustomizerUserView, TableCustomizerUser.class);
        TableCustomizerUser tableCustomizerUser = this.tableCustomizerUserDao.load(mappedTableCustomizerUser.getOid());
        if (!tableCustomizerUser.getFipDate().equals(mappedTableCustomizerUser.getFipDate())) {
            throw new OptimisticLockingFailureException("Entity 'TableCustomizerUser' was updated or deleted by another transaction.");
        }
        this.mapper.mapOne(tableCustomizerUserView, tableCustomizerUser,"updateTableCustomizerUser");
    }
    
    @Transactional
	public void deleteTableCustomizerUser(String oid) {
        Assert.notNull(oid, "parameter 'oid' must not be null");
        this.tableCustomizerUserDao.delete(oid);
    }
        
    @Transactional
    public TableCustomizerUserView saveOrUpdate(TableCustomizerUserView tableCustomizerUserView) {
        Assert.notNull(tableCustomizerUserView, "parameter 'tableCustomizerUserView' must not be null");
        if ( tableCustomizerUserView.getFipDate() == null ) {
            return this.save(tableCustomizerUserView);
        }
        else {
            this.update(tableCustomizerUserView);
            return tableCustomizerUserView;
        }
    }

    
    @Transactional(readOnly=true)
	public TableCustomizerTableView findTableForUser(String codUser,Integer numMandant,String tableName) {
        return this.mapper.createAndMapOne(this.tableCustomizerTableDao.findTableForUser(codUser,numMandant,tableName),TableCustomizerTableView.class);
    }

    @Transactional(readOnly=true)
	public TableCustomizerUserView findUser(String codUser,Integer numMandant) {
        return this.mapper.createAndMapOne(this.tableCustomizerUserDao.findUser(codUser,numMandant),TableCustomizerUserView.class);
    }

}
