package org.openxma.addons.ui.table.customizer.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerColumn;
import org.openxma.addons.ui.table.customizer.mdl.validation.TableCustomizerEntityValidator;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class TableCustomizerColumnGenValidator extends TableCustomizerEntityValidator {
    
    public boolean isNamColumnRequired(TableCustomizerColumn tableCustomizerColumn) {
        return Boolean.TRUE;
    }
    
    public boolean isTableCustomizerTableRequired(TableCustomizerColumn tableCustomizerColumn) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return TableCustomizerColumn.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(TableCustomizerColumn tableCustomizerColumn) {
        Errors errors = createErrors(tableCustomizerColumn);      
        super.validate(tableCustomizerColumn,errors);
        validate(tableCustomizerColumn,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        TableCustomizerColumn tableCustomizerColumn = (TableCustomizerColumn) object;
        if (isNamColumnRequired(tableCustomizerColumn)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "namColumn", "field.required");
        }
        if (isTableCustomizerTableRequired(tableCustomizerColumn)) {
            ValidationUtils.rejectIfEmpty(errors, "tableCustomizerTable", "field.required");
        }
        rejectIfMaxLength(errors,"namColumn",tableCustomizerColumn.getNamColumn(),255);
        rejectIfMaxLength(errors,"txtColumn",tableCustomizerColumn.getTxtColumn(),255);
        rejectIfMaxLength(errors,"codDataType",tableCustomizerColumn.getCodDataType(),16);
        rejectIfMaxLength(errors,"txtFormatterPattern",tableCustomizerColumn.getTxtFormatterPattern(),255);
    }
    
}
