package org.openxma.addons.ui.table.customizer.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerEntity;
import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class TableCustomizerEntityGenValidator extends Validators {
    
    public boolean isCodOwnerRequired(TableCustomizerEntity tableCustomizerEntity) {
        return Boolean.TRUE;
    }
    
    public boolean isNumMandantRequired(TableCustomizerEntity tableCustomizerEntity) {
        return Boolean.TRUE;
    }
    
    public boolean isFipUserRequired(TableCustomizerEntity tableCustomizerEntity) {
        return Boolean.TRUE;
    }
    
    public boolean isFipDateRequired(TableCustomizerEntity tableCustomizerEntity) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return TableCustomizerEntity.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(TableCustomizerEntity tableCustomizerEntity) {
        Errors errors = createErrors(tableCustomizerEntity);      
        validate(tableCustomizerEntity,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        TableCustomizerEntity tableCustomizerEntity = (TableCustomizerEntity) object;
        if (isCodOwnerRequired(tableCustomizerEntity)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "codOwner", "field.required");
        }
        if (isNumMandantRequired(tableCustomizerEntity)) {
            ValidationUtils.rejectIfEmpty(errors, "numMandant", "field.required");
        }
        if (isFipUserRequired(tableCustomizerEntity)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "fipUser", "field.required");
        }
        if (isFipDateRequired(tableCustomizerEntity)) {
            ValidationUtils.rejectIfEmpty(errors, "fipDate", "field.required");
        }
        rejectIfMaxLength(errors,"oid",tableCustomizerEntity.getOid(),36);
        rejectIfMaxLength(errors,"codOwner",tableCustomizerEntity.getCodOwner(),30);
        rejectIfMaxIntegerDigits(errors,"numMandant",tableCustomizerEntity.getNumMandant(),4);
        rejectIfMaxLength(errors,"fipUser",tableCustomizerEntity.getFipUser(),8);
    }
    
}
