package org.openxma.addons.ui.table.customizer.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerFilter;
import org.openxma.addons.ui.table.customizer.mdl.validation.TableCustomizerEntityValidator;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class TableCustomizerFilterGenValidator extends TableCustomizerEntityValidator {
    
    public boolean isTableCustomizerColumnRequired(TableCustomizerFilter tableCustomizerFilter) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return TableCustomizerFilter.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(TableCustomizerFilter tableCustomizerFilter) {
        Errors errors = createErrors(tableCustomizerFilter);      
        super.validate(tableCustomizerFilter,errors);
        validate(tableCustomizerFilter,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        TableCustomizerFilter tableCustomizerFilter = (TableCustomizerFilter) object;
        if (isTableCustomizerColumnRequired(tableCustomizerFilter)) {
            ValidationUtils.rejectIfEmpty(errors, "tableCustomizerColumn", "field.required");
        }
    }
    
}
