package org.openxma.addons.ui.table.customizer.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerTable;
import org.openxma.addons.ui.table.customizer.mdl.validation.TableCustomizerEntityValidator;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class TableCustomizerTableGenValidator extends TableCustomizerEntityValidator {
    
    public boolean isNamTableRequired(TableCustomizerTable tableCustomizerTable) {
        return Boolean.TRUE;
    }
    
    public boolean isTableCustomizerUserRequired(TableCustomizerTable tableCustomizerTable) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return TableCustomizerTable.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(TableCustomizerTable tableCustomizerTable) {
        Errors errors = createErrors(tableCustomizerTable);      
        super.validate(tableCustomizerTable,errors);
        validate(tableCustomizerTable,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        TableCustomizerTable tableCustomizerTable = (TableCustomizerTable) object;
        if (isNamTableRequired(tableCustomizerTable)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "namTable", "field.required");
        }
        if (isTableCustomizerUserRequired(tableCustomizerTable)) {
            ValidationUtils.rejectIfEmpty(errors, "tableCustomizerUser", "field.required");
        }
        rejectIfMaxLength(errors,"namTable",tableCustomizerTable.getNamTable(),255);
    }
    
}
