package org.openxma.addons.ui.table.customizer.mdl.validation;

import org.springframework.validation.Errors;
import org.openxma.addons.ui.table.customizer.mdl.model.TableCustomizerUser;
import org.openxma.addons.ui.table.customizer.mdl.validation.TableCustomizerEntityValidator;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class TableCustomizerUserGenValidator extends TableCustomizerEntityValidator {
    
    public boolean isCodUserRequired(TableCustomizerUser tableCustomizerUser) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return TableCustomizerUser.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(TableCustomizerUser tableCustomizerUser) {
        Errors errors = createErrors(tableCustomizerUser);      
        super.validate(tableCustomizerUser,errors);
        validate(tableCustomizerUser,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        TableCustomizerUser tableCustomizerUser = (TableCustomizerUser) object;
        if (isCodUserRequired(tableCustomizerUser)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "codUser", "field.required");
        }
        rejectIfMaxLength(errors,"codUser",tableCustomizerUser.getCodUser(),8);
    }
    
}
