package org.openxma.addons.ui.table.customizer.xma.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.xma.mdl.list.*;

/**
 * This class implements the generic server part of FilterEmDOM.
 * It implements the models of the page.
 *
 */
public abstract class FilterEmDOMGen extends org.openxma.dsl.platform.xma.DslPageServer {
    IListWM operatorCombo;
    IListWM linkOperandCombo;
    IListDomWM dom;
    WModel[] widgetModels;


    /**
     * Constructs the FilterEmDOMGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public FilterEmDOMGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        operatorCombo = new ListWM((short) 0,this, ListWM.S_NULL);
        linkOperandCombo = new ListWM((short) 1,this, ListWM.S_NULL);
        dom = new ListDomWM((short) 2,this, "null");
        ((ListDomWM)dom).setDynamicDataSource(true);

        widgetModels = new WModel[] { (WModel) operatorCombo, (WModel) linkOperandCombo, (WModel) dom };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return TableCustomizerComp.FilterEmDOMClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public TableCustomizerComp getTypedComponent() {
        return (TableCustomizerComp) getComponent();
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
