/*
 * @(#) $Id:  $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.addons.ui.table.customizer.xma.server;

import java.util.Map;

import org.openxma.addons.ui.table.customizer.common.ColumnMetaData;
import org.openxma.addons.ui.table.customizer.common.CommonTableModel;
import org.openxma.dsl.platform.query.QueryObject;

public interface ITableCustomizerServer {

    /**
     * looks for current tablefiltersettings and generates a queryobject from them.
     *
     * @return an empty queryObject if no settings are found or<br>
     *  the queryObject for the current settings
     *
     * @since 1.0
     * @author s4162
     */
    QueryObject getQueryObject();


    /**
     * same as {@link #getQueryObject()} but ignores any sorting defined in the settings.
     * Uses the given column index for sorting
     *
     * @param sortingColumnIndex
     * @param isAscending
     * @return
     * @since 1.0
     * @author s4162
     */
    QueryObject getQueryObject(int sortingColumnIndex, boolean isAscending);
    
    /**
     * gets the meta model for the table from the session.
     * 
     * @return
     * @since 4.1
     * @author s4162
     */
    CommonTableModel getTableModel();
    
    /**
     * 
     * @return
     * @since 4.1
     * @author s4162
     */
    Map<String, ColumnMetaData> getColumnMap();


}
