package org.openxma.addons.ui.table.customizer.xma.server;

import org.openxma.addons.ui.table.customizer.common.CommonTableModel;
import org.openxma.addons.ui.table.customizer.common.CommonUserModel;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.rpc.RemoteCall;
import at.spardat.xma.rpc.RemoteReply;

/**
 *
 */
public class TableCustomizerPage extends TableCustomizerPageGen {
    /**
     * Constructs the TableCustomizerPage.
     *
     * @param component
     *            the component this page belongs to
     */
    public TableCustomizerPage(ComponentServer component) {
        super(component);
    }

    public void onInit(RemoteCall call, RemoteReply reply) {
        CommonTableModel tableModel = getTypedComponent().getTableModel();
        if (tableModel != null) {
            reply.setParameter(0, tableModel); // update UI on client
        }
    }

    public void onPushTableModel(RemoteCall call, RemoteReply reply) {
        CommonTableModel tableModel = (CommonTableModel) call.getParameter(0);
        updateUserModel(tableModel);
    }

    /**
     * update the usermodel in the session
     * @param tableModel
     */
    private void updateUserModel(CommonTableModel tableModel) {
        CommonUserModel globalUserModel = getTypedComponent().getUserModel();
        globalUserModel.setTableModel(tableModel);
        getTypedComponent().setUserModel(globalUserModel);
    }

    public void onPersist(RemoteCall call, RemoteReply reply) {
        CommonTableModel tableModel = (CommonTableModel) call.getParameter(0);
        updateUserModel(tableModel);
        getTypedComponent().persist(tableModel);
    }

}
