package org.openxma.addons.ui.table.customizer.xma.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.list.*;
import at.spardat.xma.mdl.table.*;

/**
 * This class implements the generic server part of TableCustomizerPage.
 * It implements the models of the page.
 *
 */
public abstract class TableCustomizerPageGen extends org.openxma.dsl.platform.xma.DslPageServer {
    IListWM availableColumns;
    ITableWM visibleColumnsTable;
    static final int FILTERICON = 0;
    static final int COLTXT = 1;
    ITableWM sortingTable;
    static final int ICON = 0;
    static final int COLNAME = 1;
    ITableWM sortingCandidatesTable;
    static final int SORTCANDIDATECOLUMN = 0;
    WModel[] widgetModels;


    /**
     * Constructs the TableCustomizerPageGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public TableCustomizerPageGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        availableColumns = new ListWM((short) 0,this, ListWM.S_NULL);
        visibleColumnsTable = new TableWM((short) 1,this,2,TableWM.S_NULL|TableWM.S_ONE_WAY);
        sortingTable = new TableWM((short) 2,this,2,TableWM.S_NULL|TableWM.S_ONE_WAY);
        sortingCandidatesTable = new TableWM((short) 3,this,1,TableWM.S_NULL|TableWM.S_ONE_WAY);

        widgetModels = new WModel[] { (WModel) availableColumns, (WModel) visibleColumnsTable, (WModel) sortingTable, (WModel) sortingCandidatesTable };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return TableCustomizerComp.TableCustomizerPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public TableCustomizerComp getTypedComponent() {
        return (TableCustomizerComp) getComponent();
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
